# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`device_manager::conf`](#device_managerconf)
* [`device_manager::devices`](#device_managerdevices)
* [`device_manager::fact`](#device_managerfact)
* [`device_manager::run`](#device_managerrun)
* [`device_manager::run::via_cron::untargeted`](#device_managerrunvia_cronuntargeted)
* [`device_manager::run::via_exec::untargeted`](#device_managerrunvia_execuntargeted)
* [`device_manager::run::via_scheduled_task::untargeted`](#device_managerrunvia_scheduled_taskuntargeted)

### Defined types

* [`device_manager`](#device_manager)
* [`device_manager::conf::device`](#device_managerconfdevice)
* [`device_manager::fact::device`](#device_managerfactdevice)
* [`device_manager::run::via_cron::device`](#device_managerrunvia_crondevice)
* [`device_manager::run::via_exec::device`](#device_managerrunvia_execdevice)
* [`device_manager::run::via_scheduled_task::device`](#device_managerrunvia_scheduled_taskdevice)

### Functions

* [`device_manager::interval_to_cron_time`](#device_managerinterval_to_cron_time)

### Tasks

* [`run_puppet_device`](#run_puppet_device): Run puppet device on a (proxy) Puppet agent

## Classes

### `device_manager::conf`

The device_manager::conf class.

### `device_manager::devices`

The device_manager::devices class.

#### Parameters

The following parameters are available in the `device_manager::devices` class.

##### `devices`

Data type: `Hash`



Default value: `{}`

##### `defaults`

Data type: `Hash`



Default value: `{}`

### `device_manager::fact`

The device_manager::fact class.

### `device_manager::run`

The device_manager::run class.

### `device_manager::run::via_cron::untargeted`

The device_manager::run::via_cron::untargeted class.

### `device_manager::run::via_exec::untargeted`

The device_manager::run::via_exec::untargeted class.

### `device_manager::run::via_scheduled_task::untargeted`

The device_manager::run::via_scheduled_task::untargeted class.

## Defined types

### `device_manager`

The device_manager class.

#### Parameters

The following parameters are available in the `device_manager` defined type.

##### `type`

Data type: `String[1]`



##### `url`

Data type: `String`



Default value: `''`

##### `credentials`

Data type: `Hash`



Default value: `{}`

##### `debug`

Data type: `Boolean`



Default value: ``false``

##### `run_interval`

Data type: `Integer[0,1440]`



Default value: `0`

##### `run_via_exec`

Data type: `Boolean`



Default value: ``false``

##### `run_user`

Data type: `String`



Default value: `$::identity['user']`

##### `run_group`

Data type: `String`



Default value: `$::identity['group']`

##### `include_module`

Data type: `Boolean`



Default value: ``true``

##### `ensure`

Data type: `Enum[present, absent]`



Default value: `present`

### `device_manager::conf::device`

The device_manager::conf::device class.

#### Parameters

The following parameters are available in the `device_manager::conf::device` defined type.

##### `type`

Data type: `String`



##### `url`

Data type: `String`



##### `credentials`

Data type: `Hash`



##### `run_user`

Data type: `String`



##### `run_group`

Data type: `String`



##### `debug`

Data type: `Boolean`



Default value: ``false``

##### `ensure`

Data type: `Enum[present, absent]`



Default value: `present`

### `device_manager::fact::device`

The device_manager::fact::device class.

#### Parameters

The following parameters are available in the `device_manager::fact::device` defined type.

##### `ensure`

Data type: `Enum[present, absent]`



Default value: `present`

### `device_manager::run::via_cron::device`

The device_manager::run::via_cron::device class.

#### Parameters

The following parameters are available in the `device_manager::run::via_cron::device` defined type.

##### `ensure`

Data type: `String`



##### `run_interval`

Data type: `Integer`



##### `run_user`

Data type: `String`



### `device_manager::run::via_exec::device`

The device_manager::run::via_exec::device class.

### `device_manager::run::via_scheduled_task::device`

The device_manager::run::via_scheduled_task::device class.

#### Parameters

The following parameters are available in the `device_manager::run::via_scheduled_task::device` defined type.

##### `ensure`

Data type: `String`



##### `run_interval`

Data type: `Integer`



##### `run_user`

Data type: `String`



## Functions

### `device_manager::interval_to_cron_time`

Type: Puppet Language

The device_manager::interval_to_cron_time function.

#### `device_manager::interval_to_cron_time(Integer[0,1440] $interval, Integer[0,59] $offset)`

The device_manager::interval_to_cron_time function.

Returns: `Hash`

##### `interval`

Data type: `Integer[0,1440]`



##### `offset`

Data type: `Integer[0,59]`



## Tasks

### `run_puppet_device`

Run puppet device on a (proxy) Puppet agent

**Supports noop?** true

#### Parameters

##### `target`

Data type: `Optional[Pattern[/^[a-z0-9._-]+$/]]`

The name of a device in device.conf on the (proxy) Puppet agent

##### `timeout`

Data type: `Optional[Variant[Integer, Pattern[/^[0-9]+$/]]]`

The timeout in seconds for the puppet device command(s), defaults to 64

